<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Achievements{

    public $pural_name  = "Achievements";
    public $singular_name = "Achievement";
    public $post_type     = "achievements";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->display_custom_post_data();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( 'Fighter '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'show_in_nav_menus'  => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title')
        );

        register_post_type( $this->post_type, $args );
    }

    public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));

        add_action( 'restrict_manage_posts', array( $this, 'todo_restrict_manage_posts') );
        add_filter('parse_query', array( $this, 'todo_convert_restrict'));
    }

    function todo_restrict_manage_posts() {
        global $typenow;
        $args=array( 'public' => true, '_builtin' => false );
        $post_types = get_post_types($args);
        if ( in_array($typenow, $post_types) ) {
            $filters = get_object_taxonomies($typenow);
            foreach ($filters as $tax_slug) {
                $tax_obj = get_taxonomy($tax_slug);
                wp_dropdown_categories(array(
                    'show_option_all' => __('Show All '.$tax_obj->label ),
                    'taxonomy' => $tax_slug,
                    'name' => $tax_obj->name,
                    'orderby' => 'term_order',
                    'selected' => $_GET[$tax_obj->query_var],
                    'hierarchical' => $tax_obj->hierarchical,
                    'show_count' => false,
                    'hide_empty' => true
                ));
            }
        }
    }
    function todo_convert_restrict($query) {
        global $pagenow;
        global $typenow;
        if ($pagenow=='edit.php') {
            $filters = get_object_taxonomies($typenow);
            foreach ($filters as $tax_slug) {
                $var = &$query->query_vars[$tax_slug];
                if ( isset($var) ) {
                    $term = get_term_by('id',$var,$tax_slug);
                    $var = $term->slug;
                }
            }
        }
        return $query;
    }





    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Fighter Achievements Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );

        $bjj_Event_ID  = isset( $values['bjj_Event_ID'] ) ? esc_attr( $values['bjj_Event_ID'][0] ) : "";
        $bjj_Age_ID     = isset( $values['bjj_Age_ID'] ) ? esc_attr( $values['bjj_Age_ID'][0] ) : "";
        $bjj_Fighter_ID  = isset( $values['bjj_Fighter_ID'] ) ? esc_attr( $values['bjj_Fighter_ID'][0] ) : "";
        $bjj_Belt_ID  = isset( $values['bjjj_Belt_ID'] ) ? esc_attr( $values['bjjj_Belt_ID'][0] ) : "";
        $bjj_Weight_ID  = isset( $values['bjj_Weight_ID'] ) ? esc_attr( $values['bjj_Weight_ID'][0] ) : "";
        $bjj_Place  = isset( $values['bjj_Place'] ) ? esc_attr( $values['bjj_Place'][0] ) : "";
        $bjj_colour  = isset( $values['bjj_colour'] ) ? esc_attr( $values['bjj_colour'][0] ) : "";
        //echo "<pre>";
        //print_r($values);exit();
        ?>


        <p class="bjj-te-metabox-row">
        <div class="bjj-te-metabox-col-left"><label for="bjj_Fighter_ID">Fighter</label></div>
        <div class="bjj-te-metabox-col-right">
            <?php $this->bjj_get_fighter_data($bjj_Fighter_ID); ?>
        </div>
        </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Event_ID">Events</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_events_data($bjj_Event_ID); ?>
            </div>
        </p>


         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Age_ID">Age</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_age_data($bjj_Age_ID); ?>
            </div>
        </p>



         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjjj_Belt_ID">Belts</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_belt_data($bjj_Belt_ID); ?>
            </div>
        </p>


        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Weight_ID">Weight</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_weight_data($bjj_Weight_ID); ?>
            </div>
        </p>



        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Place">Place</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Place; ?>" type="text" class="bjj-te-text-field" name="bjj_Place" id="bjj_Place" /></div>
        </p
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_colour">colour</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_colour; ?>" type="text" class="bjj-te-text-field" name="bjj_colour" id="bjj_colour" /></div>
        </p





        <?php
    }

    public function bjj_get_events_data($select_events)
    {
        $events = new WP_Query('post_type=tournament-event&posts_per_page=-1');

        ?>
        <select name="bjj_Event_ID" id="bjj_Event_ID" required>
            <option value=""> Select events &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;  </option>
            <?php while ($events->have_posts()) : $events->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_events) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }





     public function bjj_get_age_data($select_age)
    {
        $age = new WP_Query('post_type=Ages&posts_per_page=-1');

        ?>
        <select name="bjj_Age_ID" id="bjj_Age_ID" required>
            <option value=""> Select Age  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp; </option>
            <?php while ($age->have_posts()) : $age->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_age) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



     public function bjj_get_belt_data($select_belts)
    {
        $belts = new WP_Query('post_type=belts&posts_per_page=-1');
        ?>
        <select name="bjjj_Belt_ID" id="bjjj_Belt_ID" required>
            <option value=""> Select Belt  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp; </option>
            <?php while ($belts->have_posts()) : $belts->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_belts) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }




     public function bjj_get_fighter_data($select_fighters)
    {
        $fighter = new WP_Query('post_type=Fighter&posts_per_page=-1');

        ?>
        <select name="bjj_Fighter_ID" id="bjj_Fighter_ID" required>
            <option value=""> Select Fighter &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  </option>
            <?php while ($fighter->have_posts()) : $fighter->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_fighters) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }


     public function bjj_get_weight_data($select_weight)
    {
        $weight = new WP_Query('post_type=weight&posts_per_page=-1');

        ?>
        <select name="bjj_Weight_ID" id="bjj_Weight_ID" required>
            <option value=""> Select Weight &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </option>
            <?php while ($weight->have_posts()) : $weight->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_weight) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );
    }

    function bjj_save_meta_data( $post_id )
    {
        // Bail if we're doing an auto save
      /*  if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'bjj_save_meta_data_nonce' ) ) return;

        // if our current user can't edit this post, bail
        if( !current_user_can( 'edit_post' ) ) return;*/


        // Make sure your data is set before trying to save it

        if( isset( $_POST['bjj_Event_ID'] ) )
            update_post_meta( $post_id, 'bjj_Event_ID', strip_tags( $_POST['bjj_Event_ID'] ) );


        if( isset( $_POST['bjj_Age_ID'] ) )
            update_post_meta( $post_id, 'bjj_Age_ID', strip_tags( $_POST['bjj_Age_ID'] ) );

         if( isset( $_POST['bjjj_Belt_ID'] ) )
            update_post_meta( $post_id, 'bjjj_Belt_ID', strip_tags( $_POST['bjjj_Belt_ID'] ) );


         if( isset( $_POST['bjj_Fighter_ID'] ) )
            update_post_meta( $post_id, 'bjj_Fighter_ID', strip_tags( $_POST['bjj_Fighter_ID'] ) );

         if( isset( $_POST['bjj_Weight_ID'] ) )
            update_post_meta( $post_id, 'bjj_Weight_ID', strip_tags( $_POST['bjj_Weight_ID'] ) );

         if( isset( $_POST['bjj_Place'] ) )
            update_post_meta( $post_id, 'bjj_Place', strip_tags( $_POST['bjj_Place'] ) );

         if( isset( $_POST['bjj_colour'] ) )
                    update_post_meta( $post_id, 'bjj_colour', strip_tags( $_POST['bjj_colour'] ) );

    }



    public function display_custom_post_data(){
        add_filter( 'manage_achievements_posts_columns', array($this,'add_achievements_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_achievements_posts_custom_column' , array($this,'attach_meta_data_to_achievements_columns' ));
    }


    function add_achievements_columns_in_data_table($columns) {
        $newVal = array(
            'bjj_Fighter_ID' => __('Fighter'),
            'bjj_Event_ID' => __('Events'),
            'bjjj_Belt_ID' =>__( 'Belt'),
            'bjj_Age_ID' =>__( 'Age'),
            'bjj_Weight_ID' =>__( 'Weight'),
            'bjj_Place' =>__( 'Place'),
            'bjj_colour' =>__( 'Colour')
        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $newVal,array_slice($columns,$afterIndex+1));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_achievements_columns( $column) {
        global $wpdb;
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj_Main_Lineage':
                echo get_post_meta( $post_id , 'bjj_Main_Lineage' , true );
                break;

            case 'bjj_Fighter_ID':
                $Post_ID_Fighter =  get_post_meta( $post_id , 'bjj_Fighter_ID' , true );
                $get_fighter_post = get_post($Post_ID_Fighter);
                echo $get_fighter_post->post_title;
                break;

            case 'bjj_Event_ID':
                $Post_ID_Events =  get_post_meta( $post_id , 'bjj_Event_ID' , true );
                $get_Event_post = get_post($Post_ID_Events);
                echo $get_Event_post->post_title;
                break;

            case 'bjjj_Belt_ID':
                $Post_ID_Belt =  get_post_meta( $post_id , 'bjjj_Belt_ID' , true );
                $get_Belt_post = get_post($Post_ID_Belt);
                echo $get_Belt_post->post_title;
                break;


            case 'bjj_Age_ID':
                $Post_ID_Age =  get_post_meta( $post_id , 'bjj_Age_ID' , true );
                $get_age_post = get_post($Post_ID_Age);
                echo $get_age_post->post_title;
                break;

            case 'bjj_Weight_ID':
                $Post_ID_Weight =  get_post_meta( $post_id , 'bjj_Weight_ID' , true );
                $get_weight_post = get_post($Post_ID_Weight);
                echo $get_weight_post->post_title;
                break;



            case 'bjj_Place':
                echo get_post_meta( $post_id , 'bjj_Place' , true );
                break;


            case 'bjj_colour':
                echo get_post_meta( $post_id , 'bjj_colour' , true );
                break;
        }
    }



}


