<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_fighter_team{

    public $pural_name  = "Fighter Teams";
    public $singular_name = "Fighter Team";
    public $post_type     = "fighter-team";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->display_FighterTeam_post_data();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'show_in_nav_menus'  => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title', 'editor' )
        );

        register_post_type( $this->post_type, $args );
    }

    public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }

    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Fighters Team  Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );

        $bjj_Valid_From  = isset( $values['bjj_Valid_From'] ) ? esc_attr( $values['bjj_Valid_From'][0] ) : "";
        $bjj_Valid_To    = isset( $values['bjj_Valid_To'] ) ? esc_attr( $values['bjj_Valid_To'][0] ) : "";
        $bjj_Team_ID     = isset( $values['bjj_Team_ID'] ) ? esc_attr( $values['bjj_Team_ID'][0] ) : "";
        $bjj_Fighter_ID  = isset( $values['bjj_Fighter_ID'] ) ? esc_attr( $values['bjj_Fighter_ID'][0] ) : "";
        //echo "<pre>";
        //print_r($values);exit();
        ?>

         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Fighter_ID">Fighters</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_fighter_data($bjj_Fighter_ID); ?>
            </div>
        </p>


        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Team_ID">Teams</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_team_data($bjj_Team_ID); ?>
            </div>
        </p>



        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Valid_From">Valid  From</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Valid_From; ?>" type="date" class="bjj-te-text-field" name="bjj_Valid_From" id="bjj_Valid_From" /></div>
        </p

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Valid_To">Valid To</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Valid_To; ?>" type="date" class="bjj-te-text-field" name="bjj_Valid_To" id="bjj_Valid_To" /></div>
        </p>



        <?php
    }

    public function bjj_get_team_data($select_team)
    {
        $team = new WP_Query('post_type=bjj-teams&posts_per_page=-1');

        ?>
        <select name="bjj_Team_ID" id="bjj_Team_ID" required style="width: 169px">
            <option value=""> Select Team </option>
            <?php while ($team->have_posts()) : $team->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_team) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



     public function bjj_get_fighter_data($select_fighters)
    {
        $fighter = new WP_Query('post_type=Fighter&posts_per_page=-1');

        ?>
        <select name="bjj_Fighter_ID" id="bjj_Fighter_ID" required style="width: 169px">
            <option value=""> Select Fighters </option>
            <?php while ($fighter->have_posts()) : $fighter->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_fighters) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );
    }

    function bjj_save_meta_data( $post_id )
    {
        // Bail if we're doing an auto save
  /*      if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'bjj_save_meta_data_nonce' ) ) return;

        // if our current user can't edit this post, bail
        if( !current_user_can( 'edit_post' ) ) return;*/


        // Make sure your data is set before trying to save it

        if( isset( $_POST['bjj_Valid_From'] ) )
            update_post_meta( $post_id, 'bjj_Valid_From', strip_tags( $_POST['bjj_Valid_From'] ) );

        if( isset( $_POST['bjj_Valid_To'] ) )
            update_post_meta( $post_id, 'bjj_Valid_To', strip_tags( $_POST['bjj_Valid_To'] ) );

        if( isset( $_POST['bjj_Team_ID'] ) )
            update_post_meta( $post_id, 'bjj_Team_ID', strip_tags( $_POST['bjj_Team_ID'] ) );

         if( isset( $_POST['bjj_Fighter_ID'] ) )
            update_post_meta( $post_id, 'bjj_Fighter_ID', strip_tags( $_POST['bjj_Fighter_ID'] ) );
    }





   public function display_FighterTeam_post_data(){
        add_filter( 'manage_fighter-team_posts_columns', array($this,'add_FighterTeam_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_fighter-team_posts_custom_column' , array($this,'attach_meta_data_to_FighterTeam_columns' ));
    }


    function add_FighterTeam_columns_in_data_table($columns) {
        return array_merge($columns,
            array(
                'bjj_Team_ID' =>__( 'Team'),
                'bjj_Fighter_ID' => __('Fighter'),
                'bjj_Valid_From' => __('Valid From'),
                'bjj_Valid_To' =>__( 'Valid To'),

             ));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_FighterTeam_columns( $column) {
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj_Valid_From':
                echo get_post_meta( $post_id , 'bjj_Valid_From' , true );
                break;

             case 'bjj_Valid_To':
                echo get_post_meta( $post_id , 'bjj_Valid_To' , true );
                break;


            case 'bjj_Fighter_ID':
                $Post_Fighter =  get_post_meta( $post_id , 'bjj_Fighter_ID' , true );
                $get_fighter_data = get_post($Post_Fighter);
                echo $get_fighter_data->post_title;
                break;

            case 'bjj_Team_ID':
                $Post_ID_team =  get_post_meta( $post_id , 'bjj_Team_ID' , true );
                $get_team_post = get_post($Post_ID_team);
                echo $get_team_post->post_title;
                break;
        }
    }







}


