<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Fighters{

    public $pural_name  = "Fighters";
    public $singular_name = "Fighter";
    public $post_type     = "fighter";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        define('WPDS_NUM_ADD_IMAGES',1); // Change number of images
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->display_Fighter_post_data();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'query_var'          => true,
                'rewrite'            => array( 'slug' =>'bjj-fighters' ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title', 'editor','thumbnail'),
                'taxonomies'         => array( 'category' ),

        );

        register_post_type( $this->post_type, $args );


        /*$labels = array(
            'name'              => _x( 'BJJ Fighters', 'taxonomy general name' ),
            'singular_name'     => _x( 'BJJ Fighter', 'taxonomy singular name' ),
            'search_items'      => __( 'Search Genres' ),
            'all_items'         => __( 'All Fighters' ),
            'parent_item'       => __( 'Parent Fighter' ),
            'parent_item_colon' => __( 'Parent Fighter:' ),
            'edit_item'         => __( 'Edit Fighter' ),
            'update_item'       => __( 'Update Fighter' ),
            'add_new_item'      => __( 'Add New ' ),
            'new_item_name'     => __( 'New Fighter Name' ),
            'menu_name'         => __( 'Fighters' ),
        );

        $args = array(
            'hierarchical'      => true,
            'labels'            => $labels,
            'show_ui'           => true,
            'show_admin_column' => true,
            'query_var'         => true,
            'rewrite'           => array( 'slug' => 'bjj-fighters' ),
        );

        register_taxonomy( 'bjj-fighters', array( 'fighter' ), $args );*/



    }

    public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }

    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Fighters Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );
        $bjj_Surname   = isset( $values['bjj_Surname'] ) ? esc_attr( $values['bjj_Surname'][0] ) : "";
        $bjj_Full_Name = isset( $values['bjj_Full_Name'] ) ? esc_attr( $values['bjj_Full_Name'][0] ) : "";
        $bjj_Nickname = isset( $values['bjj_Nickname'] ) ? esc_attr( $values['bjj_Nickname'][0] ) : "";
        $bjj_Intro = isset( $values['bjj_Intro'] ) ? esc_attr( $values['bjj_Intro'][0] ) : "";
        $bjj_Weight_ID = isset( $values['bjj_Weight_ID'] ) ? esc_attr( $values['bjj_Weight_ID'][0] ) : "";
        $bjj_Height_cm  = isset( $values['bjj_Height_cm'] ) ? esc_attr( $values['bjj_Height_cm'][0] ) : "";
        $bjj_Height_in  = isset( $values['bjj_Height_in'] ) ? esc_attr( $values['bjj_Height_in'][0] ) : "";
        $bjj_Position_ID_1  = isset( $values['bjj_Position_ID_1'] ) ? esc_attr( $values['bjj_Position_ID_1'][0] ) : "";
        $bjj_Position_ID_2  = isset( $values['bjj_Position_ID_2'] ) ? esc_attr( $values['bjj_Position_ID_2'][0] ) : "";
        $bjj_DOB            = isset( $values['bjj_DOB'] ) ? esc_attr( $values['bjj_DOB'][0] ) : "";
        $bjj_Deceased  = isset( $values['bjj_Deceased'] ) ? esc_attr( $values['bjj_Deceased'][0] ) : "";
        $bjj_attribute_name  = isset( $values['bjj_attribute_name'] ) ? esc_attr( $values['bjj_attribute_name'][0] ) : "";
        $bjj_City  = isset( $values['bjj_City'] ) ? esc_attr( $values['bjj_City'][0] ) : "";
        $bjj_Nationality  = isset( $values['bjj_Nationality'] ) ? esc_attr( $values['bjj_Nationality'][0] ) : "";
        $bjj_Valid_From  = isset( $values['bjj_Valid_From'] ) ? esc_attr( $values['bjj_Valid_From'][0] ) : "";
        $bjj_Valid_To    = isset( $values['bjj_Valid_To'] ) ? esc_attr( $values['bjj_Valid_To'][0] ) : "";
        $bjj_Team_ID     = isset( $values['bjj_Team_ID'] ) ? esc_attr( $values['bjj_Team_ID'][0] ) : "";


        //echo "<pre>";
        //print_r($values);exit();
        echo '<table>';
        for($i=0; $i<WPDS_NUM_ADD_IMAGES; $i++){
            echo ($i%2==0) ? '<tr valign="top">':'';
            echo '<td valign=top width="40%"><label>Profile Image </label> <br><input id="add_img'.$i.'_field" type="text" size="36" name="add_img'.$i.'" value="'.$this->the_additional_image_url($post->ID,$i,array(30,30)).'" />
        <input id="add_img'.$i.'" class="upload_buttons" type="button" value="Upload/Select" /></td><td width="10%" class="post_image">';
            if($this->has_additional_image($post->ID,$i) )
                echo '<a class"has_image" href="'.$this->the_additional_image_url($post->ID,$i).'" target="_blank"><img src="'.$this->the_additional_image_url($post->ID,$i,array(150,150)).'" height="150" width="150"/></a>';
            echo '</td>';
            echo (($i+1)%2==0) ? '</tr>':'';
        }
        echo '
        <tr><td colspan="4">You can specify an image URL or an attachment ID through Upload/Select button</td></tr>
    </table>';
        ?>

        <script type="text/javascript">
            jQuery(document).ready(function() {
                var formfieldID = '';
                var wpds_orig_send_to_editor = window.send_to_editor;
                jQuery('.upload_buttons').click(function() {

                    formfieldID = jQuery(this).attr('id')+'_field';
                    tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');

                    window.send_to_editor = function(html) {
                        //alert("Test");
                        //attachmentID = html.match(/wp-image-([0-9]+)/);
                        //if(attachmentID)
                        //    pasteValue = attachmentID[1];
                        //else
                        pasteValue = jQuery(html).filter('img').attr('src');

                        jQuery(".post_image").empty().append("<a href='"+pasteValue+"' target='_blank'><img src='"+pasteValue+"'  height='150' width='150'></a>");
                        jQuery('#'+formfieldID).val(pasteValue);
                        tb_remove();
                        window.send_to_editor = wpds_orig_send_to_editor;
                    }
                    return false;
                });

            });
        </script>
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Surname">Surname</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Surname; ?>"  type="text" min='0' class="bjj-te-text-field" name="bjj_Surname" id="bjj_Surname" /></div>
        </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Full_Name">Full Name</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Full_Name; ?>" type="text" class="bjj-te-text-field" name="bjj_Full_Name" id="bjj_Full_Name" /></div>
        </p>


        <p class="bjj-te-metabox-row">
        <div class="bjj-te-metabox-col-left"><label for="bjj_Nickname">Nickname</label></div>
        <!--<div class="bjj-te-metabox-col-right"><input value="<?php /*echo  $bjj_Nickname; */?>" type="textarea" class="bjj-te-text-field" name="bjj_Nickname" id="bjj_Nickname" /></div>-->
        <div class="bjj-te-metabox-col-right"><textarea class="bjj-te-text-field" name="bjj_Nickname" id="bjj_Nickname"  rows="4" cols="30"> <?php echo  $bjj_Nickname; ?></textarea>   </div>
        </p>


        <p class="bjj-te-metabox-row">
        <div class="bjj-te-metabox-col-left"><label for="bjj_Nickname">Introduction</label></div>
        <!--<div class="bjj-te-metabox-col-right"><input value="<?php /*echo  $bjj_Nickname; */?>" type="textarea" class="bjj-te-text-field" name="bjj_Nickname" id="bjj_Nickname" /></div>-->
        <div class="bjj-te-metabox-col-right"><textarea class="bjj-te-text-field" name="bjj_Intro" id="bjj_Intro"  rows="4" cols="30"> <?php echo  $bjj_Intro; ?></textarea>   </div>
        </p>


         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Weight_ID">Weight</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_weight_data($bjj_Weight_ID); ?>
            </div>
        </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Height_cm">Height cm</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Height_cm; ?>" type="number" class="bjj-te-text-field" name="bjj_Height_cm" id="bjj_Height_cm" /></div>
        </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Height_cm">Height in</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Height_in; ?>" type="number" class="bjj-te-text-field" name="bjj_Height_in" id="bjj_Height_in" /></div>
        </p>

         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_DOB">Date OF Birth</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_DOB; ?>" type="date" class="bjj-te-text-field" name="bjj_DOB" id="bjj_DOB" /></div>
        </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_City">City</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_City; ?>" type="text" class="bjj-te-text-field" name="bjj_City" id="bjj_City" /></div>
       </p>

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Nationality">Nationality</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Nationality; ?>" type="text" class="bjj-te-text-field" name="bjj_Nationality" id="bjj_Nationality" /></div>
       </p>


         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Team_ID">Teams</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_team_data($bjj_Team_ID); ?>
            </div>
        </p>



        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Valid_From">Valid  From</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Valid_From; ?>" type="date" class="bjj-te-text-field" name="bjj_Valid_From" id="bjj_Valid_From" /></div>
        </p

        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Valid_To">Valid To</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Valid_To; ?>" type="date" class="bjj-te-text-field" name="bjj_Valid_To" id="bjj_Valid_To" /></div>
        </p>


          <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Deceased">Deceased</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Deceased ; ?>" type="text" class="bjj-te-text-field" name="bjj_Deceased" id="bjj_Deceased" /></div>
        </p>


        <!-- <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Deceased">Deceased</label></div>
            <div class="bjj-te-metabox-col-right"><input value="YES" <?php /*if($bjj_Deceased == 'YES'){ echo "checked='checked'";}*/?> type="checkbox" class="bjj-te-text-field" name="bjj_Deceased" id="bjj_Deceased" /></div>
        </p>-->
        <?php
    }

    public function has_additional_image($post_id, $id=1) {

        $meta = get_post_meta($post_id,'add_img'.$id, true);
        if(empty($meta))    return false;
        return true;
    }

    function the_additional_image_url($post_id, $id=1, $size='') {
        $meta = get_post_meta($post_id,'add_img'.$id, true);
        if(empty($meta))    return false;
        if(is_numeric($meta)){
            $image = wp_get_attachment_image_src($meta, array(300,336));
            if(!empty($image))
                return $image[0];
            return false;
        }
        else{
            return $meta;
        }
    }

     public function bjj_get_team_data($select_team)
    {
        $team = new WP_Query('post_type=bjj-teams&posts_per_page=-1');

        ?>
        <select name="bjj_Team_ID" id="bjj_Team_ID" required style="width: 169px">
            <option value=""> Select Team </option>
            <?php while ($team->have_posts()) : $team->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_team) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }


    public function bjj_get_weight_data($select_weight)
    {
        $weight = new WP_Query('post_type=weight&posts_per_page=-1');

        ?>
        <select name="bjj_Weight_ID" id="bjj_Weight_ID" required style="width: 167px">
              <option value="" >Select Weight</option>
            <?php while ($weight->have_posts()) : $weight->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_weight) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }


     public function bjj_get_position_1_data($select_position_1)
    {
        $position_1 = new WP_Query('post_type=positions&posts_per_page=-1');

        ?>
        <select name="bjj_Position_ID_1" id="bjj_Position_ID_1" required style="width: 167px">
            <option value="" style="width: 167px"> Select Position 1 </option>
            <?php while ($position_1->have_posts()) : $position_1->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_position_1) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }


     public function bjj_get_position_2_data($select_position_2)
    {
        $position_2 = new WP_Query('post_type=positions&posts_per_page=-1');

        ?>
        <select name="bjj_Position_ID_2" id="bjj_Position_ID_2" required style="width: 167px">
            <option value="" style="width: 167px"> Select Position 2 </option>
            <?php while ($position_2->have_posts()) : $position_2->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_position_2) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );
    }

    function bjj_save_meta_data( $post_id )
    {
        // Bail if we're doing an auto save
       /* if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'bjj_save_meta_data_nonce' ) ) return;

        // if our current user can't edit this post, bail
        if( !current_user_can( 'edit_post' ) ) return;*/


        // Make sure your data is set before trying to save it
        for($i=0; $i<WPDS_NUM_ADD_IMAGES; $i++){
            if(isset($_POST['add_img'.$i]))
                update_post_meta($post_id, 'add_img'.$i, $_POST['add_img'.$i]);
        }

        if( isset( $_POST['bjj_Surname'] ) )
            update_post_meta( $post_id, 'bjj_Surname', strip_tags( $_POST['bjj_Surname'] ) );

        if( isset( $_POST['bjj_Full_Name'] ) )
            update_post_meta( $post_id, 'bjj_Full_Name', strip_tags( $_POST['bjj_Full_Name'] ) );


        if( isset( $_POST['bjj_Nickname'] ) )
            update_post_meta( $post_id, 'bjj_Nickname', strip_tags( $_POST['bjj_Nickname'] ) );


        if( isset( $_POST['bjj_Intro'] ) )
            update_post_meta( $post_id, 'bjj_Intro', strip_tags( $_POST['bjj_Intro'] ) );

        if( isset( $_POST['bjj_Weight_ID'] ) )
            update_post_meta( $post_id, 'bjj_Weight_ID', strip_tags( $_POST['bjj_Weight_ID'] ) );

        if( isset( $_POST['bjj_Height_cm'] ) )
            update_post_meta( $post_id, 'bjj_Height_cm', strip_tags( $_POST['bjj_Height_cm'] ) );

         if( isset( $_POST['bjj_Height_in'] ) )
            update_post_meta( $post_id, 'bjj_Height_in', strip_tags( $_POST['bjj_Height_in'] ) );

          if( isset( $_POST['bjj_DOB'] ) )
            update_post_meta( $post_id, 'bjj_DOB', strip_tags( $_POST['bjj_DOB'] ) );

        if( isset( $_POST['bjj_Deceased'] ) )
            update_post_meta( $post_id, 'bjj_Deceased', strip_tags( $_POST['bjj_Deceased'] ) );



        if( isset( $_POST['bjj_City'] ) )
            update_post_meta( $post_id, 'bjj_City', strip_tags( $_POST['bjj_City'] ) );


        if( isset( $_POST['bjj_Nationality'] ) )
            update_post_meta( $post_id, 'bjj_Nationality', strip_tags( $_POST['bjj_Nationality'] ) );

         if( isset( $_POST['bjj_Valid_From'] ) )
            update_post_meta( $post_id, 'bjj_Valid_From', strip_tags( $_POST['bjj_Valid_From'] ) );

        if( isset( $_POST['bjj_Valid_To'] ) )
            update_post_meta( $post_id, 'bjj_Valid_To', strip_tags( $_POST['bjj_Valid_To'] ) );

        if( isset( $_POST['bjj_Team_ID'] ) )
            update_post_meta( $post_id, 'bjj_Team_ID', strip_tags( $_POST['bjj_Team_ID'] ) );


    }




     public function display_Fighter_post_data(){
        add_filter( 'manage_fighter_posts_columns', array($this,'add_Fighter_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_fighter_posts_custom_column' , array($this,'attach_meta_data_to_Fighter_columns' ));
    }


    function add_Fighter_columns_in_data_table($columns) {
        $newVal = array(
            'bjj_Surname' =>__( 'SurName'),
            'bjj_Full_Name' => __('Full Name'),
            'bjj_Nickname' => __('Nickname'),
            'bjj_Height_cm' =>__( 'Height CM'),
            'bjj_Height_in' =>__( 'Height in'),
            'bjj_Weight_ID' =>__( 'Weight'),
            'bjj_DOB' =>__( 'Date Of Birth'),
            'bjj_Deceased' =>__( 'Deceased'),
            'bjj_Nationality' =>__( 'Nationailty'),

        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $newVal,array_slice($columns,$afterIndex+1));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_Fighter_columns( $column) {
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {

             case 'bjj_Surname':
                echo get_post_meta( $post_id , 'bjj_Surname' , true );
                break;

             case 'bjj_Full_Name':
                echo get_post_meta( $post_id , 'bjj_Full_Name' , true );
                break;


            case 'bjj_Nickname':
                echo get_post_meta( $post_id , 'bjj_Nickname' , true );
                break;

            case 'bjj_Height_cm':
                echo get_post_meta( $post_id , 'bjj_Height_cm' , true );
                break;

            case 'bjj_Height_in':
                echo get_post_meta( $post_id , 'bjj_Height_in' , true );
                break;


            case 'bjj_Weight_ID':
                $Post_Weight_ID =  get_post_meta( $post_id , 'bjj_Weight_ID' , true );
                $get_Weight_data = get_post($Post_Weight_ID);
                echo $get_Weight_data->post_title;
                break;

            case 'bjj_DOB':
                echo get_post_meta( $post_id , 'bjj_DOB' , true );
                break;

            case 'bjj_Deceased':
                echo get_post_meta( $post_id , 'bjj_Deceased' , true );
                break;

            case 'bjj_Nationality':
                echo get_post_meta( $post_id , 'bjj_Nationality' , true );
                break;

            case 'bjj_Team_ID':
                $Post_ID_team =  get_post_meta( $post_id , 'bjj_Team_ID' , true );
                $get_team_post = get_post($Post_ID_team);
                echo $get_team_post->post_title;
                break;
        }
    }












}


