<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Lineage{

    public $pural_name  = "Lineages";
    public $singular_name = "Lineage";
    public $post_type     = "lineage";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->display_custom_post_data();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'show_in_nav_menus'  => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title' )
        );

        register_post_type( $this->post_type, $args );
    }

    public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }

    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'LineAge Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );

        $bjj_Fighter_ID  = isset( $values['bjj_Fighter_ID'] ) ? esc_attr( $values['bjj_Fighter_ID'][0] ) : "";
        $bjj_Coach_ID    = isset( $values['bjj_Coach_ID'] ) ? esc_attr( $values['bjj_Coach_ID'][0] ) : "";
        $Main_Lineage     = isset( $values['bjj_Main_Lineage'] ) ? esc_attr( $values['bjj_Main_Lineage'][0] ) : "";

        //echo "<pre>";
        //print_r($values);exit();
        ?>


        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Fighter_ID">Fighters</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_fighter_data($bjj_Fighter_ID); ?>
            </div>
        </p>

         <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Coach_ID">Coach</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_coach_data($bjj_Coach_ID); ?>
            </div>
        </p>


        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Main_Lineage">Main Line</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $Main_Lineage; ?>" type="text" class="bjj-te-text-field" name="bjj_Main_Lineage" id="bjj_Main_Lineage" /></div>
        </p



        <?php
    }

    public function bjj_get_coach_data($select_coach)
    {
        //$coach = new WP_Query('post_type=fighter');
        $coach = new WP_Query('post_type=fighter&posts_per_page=-1');

        ?>
        <select name="bjj_Coach_ID" id="bjj_Coach_ID" required style="width: 169px">
            <option value=""> Select Coach </option>
            <?php while ($coach->have_posts()) : $coach->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_coach) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



     public function bjj_get_fighter_data($select_fighters)
    {
        $fighter = new WP_Query('post_type=fighter&posts_per_page=-1');

        ?>
        <select name="bjj_Fighter_ID" id="bjj_Fighter_ID" required style="width: 169px">
            <option value=""> Select Fighters </option>
            <?php while ($fighter->have_posts()) : $fighter->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_fighters) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

        <?php endwhile; ?>
        </select>
        <?php
    }



    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );

    }

    function bjj_save_meta_data( $post_id )
    {
      /*  // Bail if we're doing an auto save
        if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'bjj_save_meta_data_nonce' ) ) return;

        // if our current user can't edit this post, bail
        if( !current_user_can( 'edit_post' ) ) return;*/


        // Make sure your data is set before trying to save it



        if( isset( $_POST['bjj_Main_Lineage'] ) )
            update_post_meta( $post_id, 'bjj_Main_Lineage', strip_tags( $_POST['bjj_Main_Lineage'] ) );

        if( isset( $_POST['bjj_Coach_ID'] ) )
            update_post_meta( $post_id, 'bjj_Coach_ID', strip_tags( $_POST['bjj_Coach_ID'] ) );

         if( isset( $_POST['bjj_Fighter_ID'] ) )
            update_post_meta( $post_id, 'bjj_Fighter_ID', strip_tags( $_POST['bjj_Fighter_ID'] ) );


        $get_fighter = get_post($_POST['bjj_Fighter_ID']);
        $get_coach = get_post($_POST['bjj_Coach_ID']);

        $Fighter_Coach_Names =  $get_fighter->post_title." - ".$get_coach->post_title;


        $my_post = array(
            'ID'           => $post_id,
            'post_title'   => $Fighter_Coach_Names
        );

        /*remove_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );
        wp_update_post( $my_post );*/

    }


     public function display_custom_post_data(){
        add_filter( 'manage_lineage_posts_columns', array($this,'add_lineage_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_lineage_posts_custom_column' , array($this,'attach_meta_data_to_lineage_columns' ));
    }


    function add_lineage_columns_in_data_table($columns) {
        $newVal = array(
            'bjj_Fighter_ID' => __('Fighter'),
            'bjj_Coach_ID' =>__( 'Coach'),
            'bjj_Main_Lineage' => __('Main Lineage'),

        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $newVal,array_slice($columns,$afterIndex+1));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_lineage_columns( $column) {
        global $wpdb;
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj_Main_Lineage':
                echo get_post_meta( $post_id , 'bjj_Main_Lineage' , true );
                break;

            case 'bjj_Fighter_ID':
                $Post_ID_Fighter =  get_post_meta( $post_id , 'bjj_Fighter_ID' , true );
                $get_fighter_post = get_post($Post_ID_Fighter);
                echo $get_fighter_post->post_title;
                break;

            case 'bjj_Coach_ID':
                $Post_ID_Coach =  get_post_meta( $post_id , 'bjj_Coach_ID' , true );
                $get_coach_post = get_post($Post_ID_Coach);
                echo $get_coach_post->post_title;
                break;
        }
    }


}


