<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Teams{

    public $pural_name  = "Teams";
    public $singular_name = "Team";
    public $post_type     = "bjj-teams";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        define('WPDS_NUM_ADD_IMAGES',1); // Change number of images
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_team_meta_action();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
            'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
            'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
            'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
            'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
            'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
            'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
            'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
            'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
            'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
            'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
            'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
            'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
            'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
            'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
            'labels'             => $labels,
            'description'        => __( 'Description.', 'your-plugin-textdomain' ),
            'public'             => true,
            'publicly_queryable' => true,
            'show_ui'            => true,
            'show_in_menu'       => $this->bjj_admin_menu,
            'show_in_nav_menus'  => true,
            'query_var'          => true,
            'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
            'capability_type'    => 'post',
            'has_archive'        => true,
            'hierarchical'       => false,
            'menu_position'      => null,
            'supports'           => array( 'title','thumbnail','filter' )
        );

        register_post_type( $this->post_type, $args );
    }

    public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_team_meta_box'));
    }

    public function bjj_team_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Team Details', array( $this, 'bjj_team_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }



    public function bjj_team_meta_box_add($post)
    {

        echo '<table>';
        for($i=0; $i<WPDS_NUM_ADD_IMAGES; $i++){
            echo ($i%2==0) ? '<tr valign="top">':'';
            echo '<td valign=top width="40%"><label>Upload Logo  </label> <br><input id="add_img'.$i.'_field" type="text" size="36" name="add_img'.$i.'" value="'.$this->the_additional_image_url($post->ID,$i,array(30,30)).'" />
        <input id="add_img'.$i.'" class="upload_buttons" type="button" value="Upload/Select" /></td><td width="10%" class="post_image">';
            if($this->has_additional_image($post->ID,$i) )
                echo '<a class"has_image" href="'.$this->the_additional_image_url($post->ID,$i).'" target="_blank"><img src="'.$this->the_additional_image_url($post->ID,$i,array(150,150)).'" height="150" width="150"/></a>';
            echo '</td>';
            echo (($i+1)%2==0) ? '</tr>':'';
        }
        echo '
        <tr><td colspan="4">You can specify an image URL or an attachment ID through Upload/Select button</td></tr>
    </table>';
        ?>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                var formfieldID = '';
                var wpds_orig_send_to_editor = window.send_to_editor;
                jQuery('.upload_buttons').click(function() {
					
                    formfieldID = jQuery(this).attr('id')+'_field';
                    tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');

                    window.send_to_editor = function(html) {
						//alert("Test");
                        //attachmentID = html.match(/wp-image-([0-9]+)/);
                        //if(attachmentID)
                        //    pasteValue = attachmentID[1];
                        //else
                        pasteValue = jQuery(html).filter('img').attr('src');
					
						jQuery(".post_image").empty().append("<a href='"+pasteValue+"' target='_blank'><img src='"+pasteValue+"'  height='150' width='150'></a>");
                        jQuery('#'+formfieldID).val(pasteValue);
                        tb_remove();
                        window.send_to_editor = wpds_orig_send_to_editor;
                    }
                    return false;
                });

            });
        </script>
        <?php
    }


    public function has_additional_image($post_id, $id=1) {

        $meta = get_post_meta($post_id,'add_img'.$id, true);
        if(empty($meta))    return false;
        return true;
    }

    function the_additional_image_url($post_id, $id=1, $size='post-thumbnail') {
        $meta = get_post_meta($post_id,'add_img'.$id, true);
        if(empty($meta))    return false;
        if(is_numeric($meta)){
            $image = wp_get_attachment_image_src($meta, $size);
            if(!empty($image))
                return $image[0];
            return false;
        }
        else{
            return $meta;
        }
    }





    public function bjj_save_team_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_team_meta_data' ) );
    }

    function bjj_save_team_meta_data( $post_id )
    {
        for($i=0; $i<WPDS_NUM_ADD_IMAGES; $i++){
            if(isset($_POST['add_img'.$i]))
                update_post_meta($post_id, 'add_img'.$i, $_POST['add_img'.$i]);
        }

    }




}


