<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Tournament_Events{    
    
    public $pural_name  = "Tournament Events";
    public $singular_name = "Tournament Event";
    public $post_type     = "tournament-event";
    public $bjj_admin_menu = '';
    
    public function __construct($menu_name) 
    {   
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->add_TournamentEvent_columns_in_data_table();
    }
    
    public function bjj_register_post_type() 
    {        
        
        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'show_in_nav_menus'  => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title')
        );

        register_post_type( $this->post_type, $args );
    }
    
    public function bjj_meta_box()
    {        
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }
    
    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Tournament Events Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }
    
    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );
        $bjj_te_venue       = isset( $values['bjj_te_venue'] ) ? esc_attr( $values['bjj_te_venue'][0] ) : "";
        $bjj_te_year        = isset( $values['bjj_te_year'] ) ? esc_attr( $values['bjj_te_year'][0] ) : "";
        $bjj_te_city        = isset( $values['bjj_te_city'] ) ? esc_attr( $values['bjj_te_city'][0] ) : "";
        $bjj_te_country     = isset( $values['bjj_te_country'] ) ? esc_attr( $values['bjj_te_country'][0] ) : "";
        $bjj_te_fdate       = isset( $values['bjj_te_fdate'] ) ? esc_attr( $values['bjj_te_fdate'][0] ) : "";
        $bjj_te_tdate       = isset( $values['bjj_te_tdate'] ) ? esc_attr( $values['bjj_te_tdate'][0] ) : "";
        $bjj_tournament_id  = isset( $values['bjj_tournament_id'] ) ? esc_attr( $values['bjj_tournament_id'][0] ) : "";
        //echo "<pre>";
        //print_r($values);exit();
        ?>
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_venue">Venue</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_venue; ?>" type="text" class="bjj-te-text-field" name="bjj_te_venue" id="bjj_te_venue" /></div>           
        </p
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_year">Year</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_year; ?>"  type="number" min='0' class="bjj-te-text-field" name="bjj_te_year" id="bjj_te_year" /></div>
        </p>
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_city">City</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_city; ?>" type="text" class="bjj-te-text-field" name="bjj_te_city" id="bjj_te_city" /></div>
        </p
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_country">Country</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_country; ?>" type="text" class="bjj-te-text-field" name="bjj_te_country" id="bjj_te_country" /></div>
        </p
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_fdate">From Date</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_fdate; ?>" type="date" class="bjj-te-text-field" name="bjj_te_fdate" id="bjj_te_fdate" /></div>
        </p
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_te_tdate">To Date</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_te_tdate; ?>" type="date" class="bjj-te-text-field" name="bjj_te_tdate" id="bjj_te_tdate" /></div>
        </p>
        
        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_tournament_id">Tournament</label></div>
            <div class="bjj-te-metabox-col-right">
                <?php $this->bjj_get_tournaments_data($bjj_tournament_id); ?>
            </div>
        </p>
        
        <?php  
    }
       
    public function bjj_get_tournaments_data($select_tournament)
    {        
        $tournament = new WP_Query('post_type=tournament&posts_per_page=-1');
        
        ?>
        <select name="bjj_tournament_id" id="bjj_tournament_id" required style="width: 169px">
            <option value=""> Select Tournament </option>
            <?php while ($tournament->have_posts()) : $tournament->the_post(); ?>
            <?php $selected = (get_the_ID() == $select_tournament) ? "selected" : "";?>
            <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>
        
        <?php endwhile; ?>
        </select>
        <?php 
    }
    
    
    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data' ) );
    }
    
    function bjj_save_meta_data( $post_id )
    {        
        // Bail if we're doing an auto save
  /*      if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

        // if our nonce isn't there, or we can't verify it, bail
        if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'bjj_save_meta_data_nonce' ) ) return;

        // if our current user can't edit this post, bail
        if( !current_user_can( 'edit_post' ) ) return;*/

        
        // Make sure your data is set before trying to save it
        if( isset( $_POST['bjj_te_venue'] ) )
            update_post_meta( $post_id, 'bjj_te_venue', strip_tags( $_POST['bjj_te_venue'] ) );
        
        if( isset( $_POST['bjj_te_year'] ) )
            update_post_meta( $post_id, 'bjj_te_year', strip_tags( $_POST['bjj_te_year'] ) );
        
        if( isset( $_POST['bjj_te_city'] ) )
            update_post_meta( $post_id, 'bjj_te_city', strip_tags( $_POST['bjj_te_city'] ) );
        
        if( isset( $_POST['bjj_te_country'] ) )
            update_post_meta( $post_id, 'bjj_te_country', strip_tags( $_POST['bjj_te_country'] ) );
        
        if( isset( $_POST['bjj_te_fdate'] ) )
            update_post_meta( $post_id, 'bjj_te_fdate', strip_tags( $_POST['bjj_te_fdate'] ) );
        
        if( isset( $_POST['bjj_te_tdate'] ) )
            update_post_meta( $post_id, 'bjj_te_tdate', strip_tags( $_POST['bjj_te_tdate'] ) );

        if( isset( $_POST['bjj_tournament_id'] ) )
            update_post_meta( $post_id, 'bjj_tournament_id', strip_tags( $_POST['bjj_tournament_id'] ) );
    }



      public function add_TournamentEvent_columns_in_data_table(){
        add_filter( 'manage_tournament-event_posts_columns', array($this,'add_Tournament_Event_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_tournament-event_posts_custom_column' , array($this,'attach_meta_data_to_Tournament_Event_columns' ));
    }


    function add_Tournament_Event_columns_in_data_table($columns) {
        $newVal = array(
            'bjj_tournament_id' => __('Tournament'),
            'bjj_te_venue' => __('venue'),
            'bjj_te_year' =>__( 'Year'),
            'bjj_te_city' =>__( 'City'),
            'bjj_te_country' =>__( 'Country'),
            'bjj_te_fdate' => __('From Date'),
            'bjj_te_tdate' => __('To Date')

        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $newVal,array_slice($columns,$afterIndex+1));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_Tournament_Event_columns( $column) {
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj_te_venue':
                echo get_post_meta( $post_id , 'bjj_te_venue' , true );
                break;

             case 'bjj_te_year':
                echo get_post_meta( $post_id , 'bjj_te_year' , true );
                break;

            case 'bjj_te_city':
              echo get_post_meta( $post_id , 'bjj_te_city' , true );
              break;

            case 'bjj_te_country':
              echo get_post_meta( $post_id , 'bjj_te_country' , true );
              break;

            case 'bjj_te_fdate':
              echo get_post_meta( $post_id , 'bjj_te_fdate' , true );
              break;

             case 'bjj_te_tdate':
              echo get_post_meta( $post_id , 'bjj_te_tdate' , true );
              break;

            case 'bjj_tournament_id':
                $Post_Tournament =  get_post_meta( $post_id , 'bjj_tournament_id' , true );
                $get_Tournament_data = get_post($Post_Tournament);
                echo $get_Tournament_data->post_title;
                break;


        }
    }













}


