<?php

/*
 * CLASS TOURNMENT
 */

class BJJ_Tournament{    
    
    public $pural_name      = "Tournaments";
    public $singular_name   = "Tournament";
    public $post_type       = "tournament";
    public $bjj_admin_menu  = '';
    
    public function __construct($menu_name) 
    {   
        $this->bjj_admin_menu  = $menu_name;
        $this->bbj_register_post_type();
        $this->bjj_meta_box();
        $this->bjj_save_meta_action();
        $this->display_tournament_post_data();
        //$this->display_tournament_post_data();
    }
    
    public function bbj_register_post_type() 
    {        
        
        $labels = array(
                'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
                'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
                'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
                'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
                'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
                'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
                'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
                'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
                'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
                'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
                'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
                'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
                'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
                'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
                'labels'             => $labels,
                'description'        => __( 'Description.', 'your-plugin-textdomain' ),
                'public'             => true,
                'publicly_queryable' => true,
                'show_ui'            => true,
                'show_in_menu'       => $this->bjj_admin_menu,
                'show_in_nav_menus'  => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => strtolower($this->ingular_name) ),
                'capability_type'    => 'post',
                'has_archive'        => true,
                'hierarchical'       => false,
                'menu_position'      => null,
                'supports'           => array( 'title', 'editor' )
        );

        register_post_type( $this->post_type, $args );
    }

     public function bjj_meta_box()
    {
        add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }

    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-te-meta-box-id', 'Tournament Details', array( $this, 'bjj_te_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_te_meta_box_add($post)
    {
        $values = get_post_custom( $post->ID );

        $bjj_Federation  = isset( $values['bjj_Federation'] ) ? esc_attr( $values['bjj_Federation'][0] ) : "";

        //echo "<pre>";
        //print_r($values);exit();
        ?>


        <p class="bjj-te-metabox-row">
            <div class="bjj-te-metabox-col-left"><label for="bjj_Federation">Federation</label></div>
            <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_Federation; ?>" type="text" class="bjj-te-text-field" name="bjj_Federation" id="bjj_Federation" /></div>
        </p



        <?php
    }


    public function bjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjj_save_meta_data'));
    }

     function bjj_save_meta_data( $post_id )
    {
        if( isset( $_POST['bjj_Federation'] ) )
            update_post_meta( $post_id, 'bjj_Federation', strip_tags( $_POST['bjj_Federation'] ) );

    }


    public function display_tournament_post_data(){
        add_filter( 'manage_tournament_posts_columns', array($this,'add_tournament_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_tournament_posts_custom_column' , array($this,'attach_meta_data_to_tournament_columns' ));
    }


    function add_tournament_columns_in_data_table($columns) {
        $data_array = array(
            'bjj_Federation' => __('Federation'),

        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $data_array,array_slice($columns,$afterIndex+1));

    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */




    function attach_meta_data_to_tournament_columns( $column) {
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj_Federation':
                echo get_post_meta( $post_id , 'bjj_Federation' , true );
                break;
        }

    }

}