<?php

/*
 * CLASS TOURNMENT Events
 */

class BJJ_Weight{

    public $pural_name  = "Weights";
    public $singular_name = "Weight";
    public $post_type     = "weight";
    public $bjj_admin_menu = '';

    public function __construct($menu_name)
    {
        $this->bjj_admin_menu  = $menu_name;
        $this->bjj_register_post_type();
        $this->bjj_meta_box();
        $this->bjjj_save_meta_action();
        $this->display_custom_post_data();
    }

    public function bjj_register_post_type()
    {

        $labels = array(
            'name'               => _x( $this->pural_name, 'post type general name', 'your-plugin-textdomain' ),
            'singular_name'      => _x( $this->singular_name, 'post type singular name', 'your-plugin-textdomain' ),
            'menu_name'          => _x( $this->pural_name, 'admin menu', 'your-plugin-textdomain' ),
            'name_admin_bar'     => _x( $this->singular_name, 'add new on admin bar', 'your-plugin-textdomain' ),
            'add_new'            => _x( 'Add New', $this->singular_name , 'your-plugin-textdomain' ),
            'add_new_item'       => __( 'Add New '.$this->singular_name, 'your-plugin-textdomain' ),
            'new_item'           => __( 'New '.$this->singular_name, 'your-plugin-textdomain' ),
            'edit_item'          => __( 'Edit '.$this->singular_name, 'your-plugin-textdomain' ),
            'view_item'          => __( 'View '.$this->singular_name, 'your-plugin-textdomain' ),
            'all_items'          => __( ' '.$this->pural_name, 'your-plugin-textdomain' ),
            'search_items'       => __( 'Search '.$this->pural_name, 'your-plugin-textdomain' ),
            'parent_item_colon'  => __( 'Parent '.$this->pural_name.':', 'your-plugin-textdomain' ),
            'not_found'          => __( 'No '.$this->pural_name.' found.', 'your-plugin-textdomain' ),
            'not_found_in_trash' => __( 'No '.$this->pural_name.' found in Trash.', 'your-plugin-textdomain' )
        );

        $args = array(
            'labels'             => $labels,
            'description'        => __( 'Description.', 'your-plugin-textdomain' ),
            'public'             => true,
            'publicly_queryable' => true,
            'show_ui'            => true,
            'show_in_menu'       => $this->bjj_admin_menu,
            'show_in_nav_menus'  => true,
            'query_var'          => true,
            'rewrite'            => array( 'slug' => 'bjj-fighter-weight' ),
            'capability_type'    => 'post',
            'has_archive'        => true,
            'hierarchical'       => false,
            'menu_position'      => null,
            'supports'           => array( 'title', 'thumbnail' )
        );

        register_post_type( $this->post_type, $args );
    }

    public function bjj_meta_box()
    {
        add_action('admin_init', array( $this, 'bjj_te_meta_box'));
        //add_action('add_meta_boxes',array( $this, 'bjj_te_meta_box'));
    }

    public function bjj_te_meta_box()
    {
        add_meta_box( 'bjj-weight-meta-box-id', 'Weight Details', array( $this, 'bjj_weight_meta_box_add' ), $this->post_type, 'normal', 'high' );
    }

    public function bjj_weight_meta_box_add()
    {
        global $post;
        $values = get_post_custom( $post->ID );
        $bjj_weight_kg       = isset( $values['bjj-weight-kg'] ) ? esc_attr( $values['bjj-weight-kg'][0] ) : "";
        $bjj_weight_lbs        = isset( $values['bjj-weight-lbs'] ) ? esc_attr( $values['bjj-weight-lbs'][0] ) : "";
        ?>
        <p class="bjj-weight-metabox-row">
        <div class="bjj-te-metabox-col-left"><label for="bjj-weight-kg">Weight in kg</label></div>
        <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_weight_kg; ?>" type="number" class="bjj-weight-text-field" name="bjj-weight-kg" id="bjj-weight-kg" /></div>
        </p

        <p class="bjj-te-metabox-row">
        <div class="bjj-te-metabox-col-left"><label for="bjj-weight-lbs">Weight in lbs</label></div>
        <div class="bjj-te-metabox-col-right"><input value="<?php echo $bjj_weight_lbs; ?>"  type="number" min='0' class="bjj-weight-text-field" name="bjj-weight-lbs" id="bjj-weight-lbs" /></div>
        </p>


    <?php
    }



    public function bjjj_save_meta_action()
    {
        add_action( 'save_post', array( $this, 'bjjj_save_meta_data' ),10,2 );
    }

    function bjjj_save_meta_data( $post_id )
    {
            if (isset($_POST['bjj-weight-kg']))
                update_post_meta($post_id, 'bjj-weight-kg', strip_tags($_POST['bjj-weight-kg']));

            if (isset($_POST['bjj-weight-lbs']))
                update_post_meta($post_id, 'bjj-weight-lbs',strip_tags($_POST['bjj-weight-lbs']));
    }



    public function display_custom_post_data(){
        add_filter( 'manage_weight_posts_columns', array($this,'add_weight_columns_in_data_table'));
        // Add action to the manage post column to display the data
        add_action( 'manage_weight_posts_custom_column' , array($this,'attach_meta_data_to_weight_columns' ));


        // Custom Dropdown Filter Actions
        //add_action( 'restrict_manage_posts' , array($this, 'modify_ticket_filters' ) );
        //add_filter( 'parse_query', array( $this, 'modify_filter_owner' ) );


        //add_action( 'restrict_manage_posts', 'my_restrict_manage_posts' );
    }

    function my_restrict_manage_posts() {

        // only display these taxonomy filters on desired custom post_type listings
        global $typenow;
        if ($typenow == 'fighters') {

            // create an array of taxonomy slugs you want to filter by - if you want to retrieve all taxonomies, could use get_taxonomies() to build the list
            $filters = array('plants', 'animals', 'insects');

            foreach ($filters as $tax_slug) {
                // retrieve the taxonomy object
                $tax_obj = get_taxonomy($tax_slug);
                $tax_name = $tax_obj->labels->name;
                // retrieve array of term objects per taxonomy
                $terms = get_terms($tax_slug);

                // output html for taxonomy dropdown filter
                echo "<select name='$tax_slug' id='$tax_slug' class='postform'>";
                echo "<option value=''>Show All $tax_name</option>";
                foreach ($terms as $term) {
                    // output each select option line, check against the last $_GET to show the current option selected
                    echo '<option value='. $term->slug, $_GET[$tax_slug] == $term->slug ? ' selected="selected"' : '','>' . $term->name .' (' . $term->count .')</option>';
                }
                echo "</select>";
            }
        }
    }

    // Custom Dropdown Filter Actions
    public function modify_ticket_filters()
    {

        $weight = new WP_Query('post_type=weight');

        ?>
        <select name="Weight_ID" id="Weight_ID">
            <option value="" >All Weight</option>
            <?php while ($weight->have_posts()) : $weight->the_post(); ?>
                <?php
                $select_weight = $weight->ID == $_GET['Weight_ID'] ? ' selected ' : '';
                $selected = (get_the_ID() == $select_weight) ? "selected" : "";?>
                <option value="<?php the_ID();?>" <?php echo $selected;?> > <?php the_title(); ?></option>

            <?php endwhile; ?>
        </select>
    <?php

    }

    // Custom Dropdown Filter Actions
    public function modify_filter_owner( $query )
    {

        //$doaction = WP_List_Table::current_action();
       // if ( $doaction && isset( $_GET['Weight_ID'] ) ) {
        global $typenow;
        global $pagenow;

        if( $pagenow == 'edit.php' && $typenow == 'weight' && $_GET['Weight_ID'] )
        {
            $query->query_vars[ 'meta_key' ] = 'bjj-weight-kg';
            $query->query_vars[ 'meta_value' ] = (int)$_GET['Weight_ID'];
        }

       // } elseif ( ! empty( $_GET['_wp_http_referer'] ) ) {
       //     wp_redirect( remove_query_arg( array( '_wp_http_referer', '_wpnonce' ), stripslashes( $_SERVER['REQUEST_URI'] ) ) );
       //     exit;
       // }
    }






    function add_weight_columns_in_data_table($columns) {
        $newVal = array(
            'bjj-weight-kg' => __('Weight In kg'),
            'bjj-weight-lbs' =>__( 'Weight In lbs')
        );
        $afterIndex = 1;
        return array_merge(array_slice($columns,0,$afterIndex+1), $newVal,array_slice($columns,$afterIndex+1));
    }

    /**
     * Display data in new columns
     *
     * @param  $column Current column
     *
     * @return Data for the column
     */

    function attach_meta_data_to_weight_columns( $column) {
        global $post;
        $post_id = $post->ID;

        switch ( $column ) {
            case 'bjj-weight-kg':
                echo get_post_meta( $post_id , 'bjj-weight-kg' , true );
                break;

            case 'bjj-weight-lbs':
                echo get_post_meta( $post_id , 'bjj-weight-lbs' , true );
                break;
        }
    }




}


