<?php
global $post;
global $wpdb;
$FighterID = $post->ID;
get_header();


$post_data = get_post($FighterID);
$main_post_meta = get_post_meta($FighterID);

// start getting fighter main data
$Title_Content = $post_data->post_title;
$Bio_Content = $post_data->post_content;
$feat_image = wp_get_attachment_url(get_post_thumbnail_id($post->ID));
            // getting fighter meta data
$Full_Name_Content = $main_post_meta['bjj_Full_Name'][0];
$Nick_Name_Content = $main_post_meta['bjj_Nickname'][0];
$Intro_Content = $main_post_meta['bjj_Intro'][0];
$Height_Inches_Content = $main_post_meta['bjj_Height_in'][0];
$Height_Cent_Content = $main_post_meta['bjj_Height_cm'][0];
$DOB_Content = $main_post_meta['bjj_DOB'][0];
$Place_of_Birth_Content = $main_post_meta['bjj_City'][0];
$Surname_Content = $main_post_meta['bjj_Surname'][0];
$Profile_Image = $main_post_meta['add_img0'][0];


// Start getting weight data
$get_weight_meta_data = get_post_meta($post_data->bjj_Weight_ID);
$Weight_In_KG = $get_weight_meta_data['bjj-weight-kg'][0];
$Weight_In_LBS = $get_weight_meta_data['bjj-weight-lbs'][0];

// Start getting Team data
$get_team_data = get_post($post_data->bjj_Team_ID);
$get_team_meta_data = get_post_meta($post_data->bjj_Team_ID);
$Fighter_Team_Content = $get_team_data->post_title;
$Fighter_Team_Image = $get_team_meta_data['add_img0'][0];


// getting fighter lineage
require('lineage_functions.php');
$coaches_array = array();
$fighter_array = array();

// getting all coaches of loaded fighter
get_coaches($FighterID,$coaches_array);
foreach($coaches_array as $coach){
    $co = array();
    // getting all linages
    get_lineage($coach,$co);
    // use main coach as key
    $fighter_array[$coach] = $co;
}

$fighters_black_belts_array = array();
get_black_belts($FighterID,$fighters_black_belts_array);



// Start  getting tournament, events and achievements information

$get_achievements = "SELECT
        wp_posts.ID, wp_posts.post_title,ach.*
        FROM wp_posts
        INNER JOIN wp_postmeta as ach
        ON ach.post_id = wp_posts.ID
        WHERE wp_posts.post_type = 'achievements'
        AND ach.meta_value = $FighterID
        ";
$get_fighter_achievements = $wpdb->get_results($get_achievements, OBJECT);
$achievement_detail_array = array();
foreach($get_fighter_achievements as $fighter_achievement){
    unset($fighter_achievement->meta_id);
    unset($fighter_achievement->meta_key);
    unset($fighter_achievement->meta_value);

    // getting fighter achievements data
    $get_achievement_meta_data = get_post_meta($fighter_achievement->post_id);
    $fighter_achievement->bjj_Fighter_ID = $get_achievement_meta_data['bjj_Fighter_ID'][0];
    $fighter_achievement->bjj_Event_ID = $get_achievement_meta_data['bjj_Event_ID'][0];
    $fighter_achievement->bjj_Weight_ID = $get_achievement_meta_data['bjj_Weight_ID'][0];
    $fighter_achievement->bjj_Age_ID = $get_achievement_meta_data['bjj_Age_ID'][0];
    $fighter_achievement->bjjj_Belt_ID = $get_achievement_meta_data['bjjj_Belt_ID'][0];
    $fighter_achievement->bjj_Place = $get_achievement_meta_data['bjj_Place'][0];
    $fighter_achievement->bjj_colour = $get_achievement_meta_data['bjj_colour'][0];

    // getting titles for bjj_Weight_ID bjj_Age_ID bjjj_Belt_ID
    $get_weight_title = get_post($fighter_achievement->bjj_Weight_ID);
    $fighter_achievement->weight_post_title = $get_weight_title->post_title;

    $get_age_title = get_post($fighter_achievement->bjj_Age_ID);
    $fighter_achievement->age_post_title = $get_age_title->post_title;

    $get_belt_title = get_post($fighter_achievement->bjjj_Belt_ID);
    $fighter_achievement->belt_post_title = $get_belt_title->post_title;

    $get_event_post_data = get_post($fighter_achievement->bjj_Weight_ID);
    $fighter_achievement->weight_post_title = $get_event_post_data->post_title;


    // Getting events data
    $get_event_post_data = get_post($fighter_achievement->bjj_Event_ID);
    $fighter_achievement->event_post_title = $get_event_post_data->post_title;

    $get_event_meta_data = get_post_meta($fighter_achievement->bjj_Event_ID);
    $fighter_achievement->bjj_te_year = $get_event_meta_data['bjj_te_year'][0];
    $fighter_achievement->bjj_te_venue = $get_event_meta_data['bjj_te_venue'][0];
    $fighter_achievement->bjj_te_city = $get_event_meta_data['bjj_te_city'][0];
    $fighter_achievement->bjj_te_fdate = $get_event_meta_data['bjj_te_fdate'][0];
    $fighter_achievement->bjj_te_tdate = $get_event_meta_data['bjj_te_tdate'][0];
    $fighter_achievement->bjj_tournament_id = $get_event_meta_data['bjj_tournament_id'][0];

    // Push tournament IDs to $achievement_detail_array to get concern tournaments Titles
    array_push($achievement_detail_array,$fighter_achievement->bjj_tournament_id);
}


/*
echo '<pre>';
print_r(array_unique($achievement_detail_array));
print_r($get_fighter_achievements);*/







?>

<div class="row">

    <div class="col-sm-12">
        <div class="col-sm-8">
            <div class="col-sm-4">
                <div class="a-single a-21"><img style="height: 300px; width: 240px;" border="0" alt="<?php echo $Full_Name_Content; ?>" src="<?php echo $Profile_Image; ?>"></div>

                <table class="table table-condensed" style="margin-top: 5px;">
                    <tr>
                        <td align="center" bgcolor="red" style="color: white; font-weight: bold;">BASIC INFO</td>
                    </tr>
                    <tr>
                        <td align="center">
                            <small style="font-size: 10px;">Weight Division</small></br>
                            <strong><?php echo $Weight_In_KG."/".$Weight_In_LBS; ?></strong>
                        </td>
                    </tr>
                    <tr>
                        <td align="center">
                            <small style="font-size: 10px;">Height</small></br>
                            <strong><?php echo $Height_Cent_Content."/".$Height_Inches_Content; ?>
                        </td>
                    </tr>
                    <tr>
                        <td align="center">
                            <small style="font-size: 10px;">Place of Birth</small></br>
                            <strong><?php echo $Place_of_Birth_Content; ?></strong>
                        </td>
                    </tr>
                    <tr>
                        <td align="center">
                            <small style="font-size: 10px;">DOB</small></br>
                            <strong><?php echo $DOB_Content; ?></strong>
                        </td>
                    </tr>
                    <tr>
                        <td align="center">
                            <small style="font-size: 10px;">Team/Association</small></br>
                            <strong><?php echo $Fighter_Team_Content?></strong>
                        </td>

                    </tr>
                    <tr>
                        <td align="center">
                                <img src="<?php echo $Fighter_Team_Image; ?>">
                        </td>
                    </tr>
                </table>

            </div>

            <div class="col-sm-8">
                <!--     Main Paragraph     -->
                <div class="text-content">

                    <h2 style="margin-top: 0px;"><?php echo $Title_Content; ?></h2>
                    <p style="border-bottom: 1px solid #dddddd;">
                       <a href="#main-achievement_link" style="text-decoration: none; color: #049cdb;" > Main Achievements | </a>
                       <a href="#lineage-link" style="text-decoration: none; color: #049cdb;" >Lineage |  </a>
                       <a href="#black-belts-under-link" style="text-decoration: none; color: #049cdb;" >Black Belt under <?php echo $Full_Name_Content; ?> </a>
                    </p>


                    <p>
                        <?php echo $Intro_Content; ?>
                    </p>
                </div>

                <!--     Full Name Portion     -->
                <div class="text-content" style="border-top: 1px solid #eeeeee; border-bottom: 1px solid #eeeeee; padding: 5px;">
                    <div class="row">
                        <div class="col-sm-4" style=" width: 30.333% !important;">
    FULL NAME :
                        </div>
                        <div class="col-sm-8" style="padding-left:0px; ">
    <?php echo $Full_Name_Content; ?>
</div>
                    </div>
                </div>

                <!--     NICK Name Portion     -->
                <div class="text-content" style="border-top: 1px solid #eeeeee; border-bottom: 1px solid #eeeeee; padding: 5px;">
                    <div class="row">
                        <div class="col-sm-4" style=" width: 30.333% !important;">
    NICK NAME :
                        </div>
                        <div class="col-sm-8" style="padding-left:0px; ">
                            <?php echo $Nick_Name_Content; ?>
                        </div>
                    </div>

                </div>

                <!--     LineAge  Portion     -->
                <div class="text-content" id="lineage-link" style="border-top: 1px solid #eeeeee; padding: 5px;">
                    <div class="row">
LINEAGE :

                        <?php foreach($fighter_array as $main_coach=>$coaches){?>
                        <div class="col-sm-12" style="border-bottom: 1px solid #dddddd;">

                            <div class="col-sm-4">
                                <?php
                                // display Main coach by $main_coach key
                                $main_co = get_post($main_coach);
                                $main_title_Content_Linage = $main_co->post_title;
                                echo get_the_post_thumbnail( $main_coach, 'thumbnail', array( 'class' => 'image_style' ) ); ?>
                                <small style="display:block;"><?php echo $main_title_Content_Linage; ?> >></small>
                            </div>


                            <?php
                                // display all coaches
                            foreach($coaches as $single_fighter){
                            $result = get_post($single_fighter);
                            $Title_Content_Linage = $result->post_title;
                            ?>
                            <div class="col-sm-4">
                                <?php echo get_the_post_thumbnail( $single_fighter, 'thumbnail', array( 'class' => 'image_style' ) ); ?>
                                <small style="display:block;"><?php echo $Title_Content_Linage; ?> >></small>
                            </div>
                            <?php } ?>
                        </div>
                        <?php } ?>
                    </div>

                </div>
            </div>





            <!--New Block Start Here -->



            <div class="col-sm-12" id="main-achievement_link">

                <table class="table table-condensed medals-table" style="margin-top: 5px; border-bottom: none;border-top: none;">

                    <tr>
                        <td width="31%" align="center" bgcolor="red" style="color: white; font-weight: bold;">Main Achievements</td>
                        <td width="23%" ></td>
                        <td width="23%" ></td>
                        <td width="23%" ></td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td><small><strong>GOLD MEDALS</strong></small></td>
                        <td><small><strong>SILVER MEDALS</strong></small></td>
                        <td><small><strong>BRONZE MEDALS</strong></small></td>
                    </tr>
                    <tr>
                        <td colspan="4">
                            <table class="medals-table medals-table-padding" width="100%" border="0" cellspacing="0" cellpadding="6" style="border: none; border-collapse: separate;border-spacing: 2px;">

                                <?php
                                foreach(array_unique($achievement_detail_array) as $key=>$tour){
                                    $get1=0;$get2=0; $get3=0;
                                    $get_championship_federation = get_post_meta($tour);
                                    $championship_federation = $get_championship_federation['bjj_Federation'][0];
                                ?>
                                <tr class="item">
                                    <td width="31%">
                                        <p class="achievement-p"><?php echo get_post($tour)->post_title; ?></p>
                                        <span class="foundation""><?php echo $championship_federation; ?></span>
                                    </td>
                                    <td width="23%">
                                        <span class="take1" style="font-size: 42px; float: left;"></span> <br>
                                        <?php
                                        foreach($get_fighter_achievements as $ach){
                                            if($tour == $ach->bjj_tournament_id){
                                                if($ach->bjj_Place == 1) {
                                                    ?>

                                                    <p style="font-size: 10px; margin-top: -4px;"><?php echo $ach->bjj_te_year."<span style='color:$ach->bjj_colour'> ".$ach->belt_post_title."/".$ach->age_post_title; ?></span></p>
                                        <?php
                                                    ++$get1;
                                                }
                                            }
                                        }
                                        ?>
                                        <span style="display: none;" class="get1"><?php echo $get1; ?></span>
                                    </td>

                                    <td width="24%">
                                        <span style="font-size: 42px; float: left;" class="take2"></span> <br>
                                        <?php
                                        foreach($get_fighter_achievements as $ach){
                                            if($tour == $ach->bjj_tournament_id){
                                                if($ach->bjj_Place == 2) {
                                                    ++$get2;
                                                    ?>
                                                    <p style="font-size: 10px; margin-top: -4px;"><?php echo  $ach->bjj_te_year."<span style='color:$ach->bjj_colour'> ".$ach->belt_post_title."/".$ach->age_post_title; ?></span></p>
                                                <?php
                                                }
                                            }
                                        }
                                        ?>
                                        <span style="display: none;" class="get2"><?php echo $get2; ?></span>
                                    </td>

                                    <td width="22%">
                                        <span style="font-size: 42px; float: left;" class="take3"></span> <br>
                                        <?php

                                        foreach($get_fighter_achievements as $ach){
                                            if($tour == $ach->bjj_tournament_id){
                                                if($ach->bjj_Place == 3) {
                                                    ++$get3;
                                                    ?>
                                                    <p style="font-size: 10px; margin-top: -4px;"><?php echo  $ach->bjj_te_year."<span style='color:$ach->bjj_colour'> ".$ach->belt_post_title."/".$ach->age_post_title; ?></span></p>
                                                <?php
                                                }
                                            }
                                        }
                                        ?>
                                        <span style="display: none;" class="get3"><?php echo $get3; ?></span>
                                    </td>
                                </tr>

                                <?php } ?>
                        </table>
                        </td>
                    </tr>

                </table>
            </div>





            <!-- ---------------- 2nd Last Portion ----------------- -->

            <div class="col-sm-12" id="black-belts-under-link">
                <table class="table table-condensed medals-table" style="margin-top: 5px; border-bottom: none;border-top: none;">

                    <tr>
                        <td width="31%" align="center" bgcolor="red" style="color: white; font-weight: bold;">Black Belt By <?php echo $Surname_Content; ?></td>
                        <td width="23%" ></td>
                        <td width="23%" ></td>
                        <td width="23%" ></td>
                    </tr>
                    <tr>
                        <td colspan="4">
                            <?php foreach($fighters_black_belts_array as $black_belts_by_fighter){
                                $get_belts = get_post($black_belts_by_fighter);
                                echo $get_belts->post_title." ";
                            }?>
                        </td>
                    </tr>
                </table>
            </div>





            <!-- ---------------- Last Portion ----------------- -->

            <div class="col-sm-12">
                <h2 style="margin-top: 0px;"><?php echo $Full_Name_Content; ?></h2>
                <p>
                    <?php echo $Bio_Content; ?>
                </p>
            </div>






        </div>


        <div class="col-sm-4">
            <?php get_sidebar(); ?>
        </div>
</div>
</div>
<script>
    jQuery(document).ready(function($){
        $("tr.item").each(function() {
            var get1 = $(this).find("span.get1").text();
            if(get1 != "0"){
                $(this).find("span.take1").text(get1);
                $(this).find("td:eq(1)").css("background","#faeb3a");
            }

            var get2 = $(this).find("span.get2").text();
            if(get2 != "0"){
                $(this).find("span.take2").text(get2);
                $(this).find("td:eq(2)").css("background","#bfc0bb");
            }

            var get3 = $(this).find("span.get3").text();
            if(get3 != "0"){
                $(this).find("span.take3").text(get3);
                $(this).find("td:eq(3)").css("background","#deb110");
            }

        });
    });
</script>

<?php
get_footer();